(function($) {


    $.fn.gernateChart = function() {
        //  $(this).parents().find(".ccpw-preloader").show();
        var coinId = $(this).data("coin-id");
        var mainThis = $(this);
        var coinperiod = $(this).data("coin-period");
        var label_1D = $(this).data("1d");
        var label_7D = $(this).data("7d");
        var label_1M = $(this).data("1m");
        var label_3M = $(this).data("3m");
        var label_6M = $(this).data("6m");
        var label_1Y = $(this).data("1y");
        var coinid = $(this).data("coinid");
        
        var fromLbl = $(this).data("from-lbl");
        var toLbl = $(this).data("to-lbl");
        var zoomLbl = $(this).data("zoom-lbl");
        var priceLbl = $(this).data("price-lbl");
        var currentPrice = $(this).parents('.ccpw-container.chart').find('.CCP-' + coinId).text();
        var rest_url = $(this).parents('.ccpw-container.chart').find('.coin_details').attr('data-rest-url');
        var currentVol = $(this).parents('.ccpw-container.chart').children('.CCMC').text();
        var volumeLbl = $(this).data("volume-lbl");
        var color = $(this).data("chart-color");
        var noFormatting = $(this).data("no-formatting");
        var price_section = $(this).find(".CCP-" + coinId);
        var priceData = [];
        var milliseconds = (new Date).getTime();
        if (currentPrice < 0.50) {
            var formatedPrice = numeral(currentPrice).format('00.000000')
        } else {
            var formatedPrice = numeral(currentPrice).format('00.00')
        }
        var currentPriceIndex = {
            date: milliseconds,
            value: formatedPrice.replace('$', ''),
            volume: numeral(currentVol).format('00.00')
        };
        $(this).find('.CCMC,.CCV').number(true);
        var cacheIndex = coinId + '-historical-data';
        var coinCacheData = lscache.get(cacheIndex);
        if (coinCacheData) {
            priceData = coinCacheData;
            generateChart(coinId, color, priceData, fromLbl, toLbl, zoomLbl, priceLbl, volumeLbl, label_1D, label_7D, label_1M, label_3M, label_6M, label_1Y, noFormatting, coinid)
        } else {
            var request_data = {
                'action': 'ccpw_charts',
                'coin_id': coinId,
                //'type': 'chart',
                // 'day': 31,
                'nonce': data_object.nonce
            };
            console.log(request_data);
            jQuery.ajax({
                type: "get",
                dataType: "json",
                url: data_object.ajax_url,
                data: request_data,
                async: !0,
                success: function(response) {
                     console.log(response);
                    if (response.status == "success") {

                        if (response.data.length !== 0 && response.data != null) {
                            var priceData = response.data;                        
                        //    var lastIndex = priceData[priceData.length - 1];
                          //  currentPriceIndex.volume = lastIndex.volume;
                          //  priceData.push(currentPriceIndex);
                            mainThis.find(".ccpw-preloader").hide();
                            //cached for 1 hour
                            lscache.set(coinId + '-historical-data', priceData, 120);

                            generateChart(coinId, color, priceData, fromLbl, toLbl, zoomLbl, priceLbl, volumeLbl, label_1D, label_7D, label_1M, label_3M, label_6M, label_1Y, noFormatting, coinid)
                        } else {
                            $(".chart-wrp img.ccpw-preloader").hide();
                            $(".chart-wrp span.ccpw-no-data").html("<center>No chart data found</center>");
                            mainThis.css('height', 'auto')
                            console.log('No data available!');
                        }
                    }
                }
            });
        }
    }
    var generateChart = function (coinId, chart_color, coinData, fromLbl, toLbl, zoomLbl, priceLbl, volumeLbl, label_1D, label_7D, label_1M, label_3M, label_6M, label_1Y, noFormatting, coinid) {
        $(document).ready(function () {
            jQuery("span.amcharts-range-selector-title.amcharts-range-selector-from-title").text(fromLbl);
            jQuery("span.amcharts-range-selector-title.amcharts-range-selector-to-title").text(toLbl);
            jQuery("span.amcharts-range-selector-title.amcharts-range-selector-period-title").text(zoomLbl);

        });
        am4core.ready(function () {
            am4core.useTheme(am4themes_animated);
            var chart = am4core.create('CCPW-CHART-' + coinId, am4charts.XYChart);
            chart.padding(0, 15, 0, 15);
            chart.data = coinData;
            chart.colors.list = [                
                am4core.color(chart_color),

            ];
            chart.numberFormatter.bigNumberPrefixes = [
                { "number": 1e+3, "suffix": "K" },
                { "number": 1e+6, "suffix": "M" },
                { "number": 1e+9, "suffix": "B" }
            ];
            // the following line makes value axes to be arranged vertically.
            chart.leftAxesContainer.layout = "vertical";
            // the following line makes value axes to be arranged vertically.
            chart.dateFormatter.inputDateFormat = "yyyy-MM-dd";
            var dateAxis = chart.xAxes.push(new am4charts.DateAxis());
            dateAxis.renderer.grid.template.location = 0;
            dateAxis.renderer.ticks.template.length = 8;
            //  dateAxis.renderer.minGridDistance = 50;
            dateAxis.tooltipDateFormat = "MMM dd,yyyy";
            dateAxis.renderer.ticks.template.strokeOpacity = 0.1;
            dateAxis.renderer.grid.template.disabled = true;
            dateAxis.renderer.ticks.template.disabled = false;
            dateAxis.renderer.ticks.template.strokeOpacity = 0.2;
            dateAxis.renderer.minLabelPosition = 0.01;
            dateAxis.renderer.maxLabelPosition = 0.99;
            dateAxis.keepSelection = true;
            dateAxis.minHeight = 30;
            dateAxis.groupData = true;
            dateAxis.minZoomCount = 5;

            var valueAxis = chart.yAxes.push(new am4charts.ValueAxis());
            valueAxis.tooltip.disabled = false;
            valueAxis.zIndex = 1;
            valueAxis.renderer.baseGrid.disabled = true;
            // height of axis
            valueAxis.height = am4core.percent(100);
            valueAxis.renderer.inside = false;
            valueAxis.renderer.labels.template.verticalCenter = "bottom";
            valueAxis.renderer.labels.template.padding(2, 2, 2, 2);
            valueAxis.renderer.fontSize = "0.8em"
            valueAxis.stroke = am4core.color(chart_color);
            // Create series
            var series = chart.series.push(new am4charts.LineSeries());
            // series.tooltip.label.fill = series.stroke;
            series.dataFields.dateX = "date";
            series.dataFields.valueY = "value";
            series.tooltipText = "{value}";
            series.fillOpacity = 0.1;
            series.defaultState.transitionDuration = 0.5;
            series.tooltip.getFillFromObject = false;
            series.tooltip.getStrokeFromObject = true;
            series.tooltip.background.strokeWidth = 2;
            series.strokeWidth = 2.5;
            series.tooltip.label.fill = am4core.color(chart_color);
            series.legendSettings.labelText = priceLbl + ": [bold {color}]{name}[/]";
            series.legendSettings.valueText = "{valueY.close}";
            series.legendSettings.itemValueText = "[bold]{valueY}[/bold]";

            var valueAxis2 = chart.yAxes.push(new am4charts.ValueAxis());
            valueAxis2.tooltip.disabled = false;
            // height of axis
            valueAxis2.height = am4core.percent(25);
            valueAxis2.zIndex = 3
            // this makes gap between panels
            valueAxis2.marginTop = 30;
            valueAxis2.renderer.baseGrid.disabled = true;
            valueAxis2.renderer.inside = false;
            valueAxis2.renderer.labels.template.padding(2, 2, 2, 2);
            valueAxis2.renderer.fontSize = "0.8em"
            valueAxis2.stroke = am4core.color(chart_color);
            var series2 = chart.series.push(new am4charts.ColumnSeries());
            series2.dataFields.dateX = "date";
            series2.dataFields.valueY = "volume";
            series2.yAxis = valueAxis2;
            series2.tooltipText = "Volume:${volume.formatNumber('#,###.##a')}";
            series2.tooltip.getFillFromObject = false;
            series2.tooltip.getStrokeFromObject = true;
            series2.tooltip.background.strokeWidth = 2;
            series2.tooltip.label.fill = series2.stroke;
            // volume should be summed
            series2.groupFields.valueY = "sum";
            series2.defaultState.transitionDuration = 0;
            series2.tooltip.label.fill = am4core.color(chart_color);
            series2.legendSettings.labelText = volumeLbl + ": [bold ]{name}[/]";
            series2.legendSettings.valueText = "${valueY.close.formatNumber('#,###.##a')}";
            series2.legendSettings.itemValueText = "[bold ]${valueY.formatNumber('#,###.##a')}[/bold]";
            // Add cursor            
            chart.cursor = new am4charts.XYCursor();
            /* Add legend */
            chart.legend = new am4charts.Legend();
            chart.legend.useDefaultMarker = true;
            let marker = chart.legend.markers.template.children.getIndex(0);
            //   marker.cornerRadius(12, 12, 12, 12);
            marker.strokeWidth = 0;
            marker.strokeOpacity = 1;
            //   marker.stroke = am4core.color("#ccc");
            // chart.legend.markers.template.disabled = true;
            chart.legend.itemContainers.template.clickable = false;
            chart.legend.itemContainers.template.paddingBottom = 30;
            chart.legend.labels.template.text = "Series: [bold {color}]{name}[/]";
            chart.legend.position = "top";
            chart.legend.contentAlign = "left";

            chart.numberFormatter.numberFormat = noFormatting;
            var scrollbarX = new am4charts.XYChartScrollbar();
            scrollbarX.series.push(series);
            scrollbarX.marginBottom = 20;
            scrollbarX.scrollbarChart.xAxes.getIndex(0).minHeight = undefined;
            chart.scrollbarX = scrollbarX;
            chart.scrollbarX.parent = chart.bottomAxesContainer;
            // chart.scrollbarX.unselectedOverlay.fill = am4core.color("#000");
            chart.scrollbarX.unselectedOverlay.fillOpacity = 0.5;
            chart.scrollbarX.minHeight = 40;
            chart.scrollbarX.startGrip.background.fill = am4core.color("#4c4646");
            chart.scrollbarX.endGrip.background.fill = am4core.color("#4c4646");
            chart.scrollbarX.thumb.background.fill = am4core.color("#000");
            chart.scrollbarX.thumb.background.fillOpacity = 0.2;
            // This Adapter makes negative labels red

            //  chart.scrollbarX.stroke = am4core.color("#000");
            // chart.scrollbarX.stroke.fill = am4core.color("#000");
            //   chart.scrollbarX.background.fill = am4core.color("#000");
            var selector = new am4plugins_rangeSelector.DateAxisRangeSelector();
            selector.periods = [{
                name: label_1D,
                interval: { timeUnit: "day", count: 1 }
            },
            { name: label_7D, interval: { timeUnit: "week", count: 1 } },
            { name: label_1M, interval: { timeUnit: "month", count: 1 } },
            { name: label_3M, interval: { timeUnit: 'month', count: 3 } },
            { name: label_6M, interval: { timeUnit: 'month', count: 6 } },
            { name: label_1Y, interval: { timeUnit: 'year', count: 1 } },

            ];

            selector.inputDateFormat = "dd-MM-yyyy";
            selector.container = document.createElement("div");
            selector.axis = dateAxis;
           
            jQuery('#ccpw-default-chart-'+coinid).append(selector.container);
            valueAxis2.adapter.add("getTooltipText", function (text, target) {
                return '$' + numeral(text).format('(0.00 a)').toUpperCase();
            });
            valueAxis2.renderer.labels.template.adapter.add("text", function (text, target) {
                return '$' + numeral(text).format('(0 a)').toUpperCase();
            });
            // Add legend

            $('.amcharts-range-selector-period-wrapper').ready(function () {

                var selected = $(this).find('.amcharts-range-selector-period-button');
                $(selected[5]).addClass('selected');
                $(selected).click(function () {
                    $(selected).removeClass('selected');
                    $(this).addClass("selected");
                    

                })})      
          
        });
    }

    $('.ccpw-chart').each(function(index) {
        $(this).gernateChart();
    });

})(jQuery);